#include "tratador.h"
#include "context.h"
#include "vector.h"

#define ENTRADA 0xff
#define SAIDA 0x00

#define ACENDE 0x00
#define APAGA 0xff

unsigned int Tratador::x;
int Tratador::counter;

void Tratador::acende()
{
    //at90s->portb = ACENDE;
    asm("out 0x18,%0"::"r"(0x00));
}

void Tratador::apaga() {
    //at90s->portb = APAGA;
    x = 0xff;
    asm("out 0x18,%0"::"r"(0xff));
}

void Tratador::inicialize() {
    //at90s->sreg = 0x80;  //habilita as interrupções
    x = 0x80;
    asm("out 0x3f,%0"::"r" (0x80));

    //at90s->gimsk = 0x40;
    x = 0x40;  
    asm("out 0x3b,%0"::"r"(0x40));
    //at90s->mcucr = 0x02; //habilita interrupção ao precionar o botao
    x = 0x02;
    asm("out 0x35,%0"::"r"(0x02));
    
    //at90s->ddrb = ENTRADA;
    x= 0xff;
    asm("out 0x17,%0"::"r"(0xff));

    apaga();

    counter = 0;
}

void Tratador::trataIRQ0()
{   
    static int is_down = 0; //indica se o botão foi pressionado ou liberado
    
    is_down = ~is_down;
    if (is_down)
    {
      //at90s->timsk = 0x02; //habilita interrupção de tempo
      x = 0x02;
      asm("out 0x39,%0"::"r"(0x02));
      //at90s->mcucr = 0x03; //habilita interrupção ao liberar o botao
      x = 0x03;
      asm("out 0x35,%0"::"r"(0x03));
      //at90s->tccr0 = 0x05; //overflow para 1024
      x = 0x05;
      asm("out 0x33,%0"::"r"(0x05));
    }
    else
    {
      counter = 0;  //reseta o contador

      //at90s->tccr0 = 0x00;
      x = 0x00;
      asm("out 0x33,%0"::"r"(0x00));
      //at90s->mcucr = 0x02; //habilita interrupção ao precionar o botaoi
      x = 0x02;
      asm("out 0x35,%0"::"r"(0x02));
      //at90s->tcnt0 = 0x00;
      x = 0x00;
      asm("out 0x32,%0"::"r"(0x00));

      //at90s->timsk = 0x00; //desabilita interrupção de tempo
      x = 0x00;
      asm("out 0x39,%0"::"r"(0x00));

      apaga();
    }
}

void Tratador::trataIRQ7() {
    counter++;
    if (counter == 61)
    {
      counter = 0;
      acende();
      //at90s->timsk = 0x00; //desabilita interrupção de tempo
      x = 0x00;
      asm("out 0x39,%0"::"r"(0x00));
    }
}
